package com.jjt.calc.domain;

import com.baomidou.mybatisplus.annotation.TableId;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.jjt.common.annotation.Excel;
import com.jjt.common.core.domain.BaseEntity;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
 * 1小时统计数据对象 TWIN_CALC_HOUR
 *
 * @author wukai
 * @date 2025-01-18
 */
@ApiModel(value = "TwinCalcHour", description = "1小时统计数据")
@Data
public class TwinCalcHour extends BaseEntity {
    private static final long serialVersionUID = 1L;

    /**
     * ID
     */
    @ApiModelProperty("ID")
    @TableId
    private Long id;

    /**
     * 日期
     */
    @ApiModelProperty("日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @Excel(name = "日期", width = 30, dateFormat = "yyyy-MM-dd")
    private Date dataDate;

    /**
     * 小时;0-23
     */
    @ApiModelProperty("小时;0-23")
    @Excel(name = "小时;0-23")
    private Integer hour;

    /**
     * 设备ID
     */
    @ApiModelProperty("设备ID")
    @Excel(name = "设备ID")
    private Long deviceId;

    /**
     * 电量
     */
    @ApiModelProperty("电量")
    @Excel(name = "电量")
    private BigDecimal kwh;

    /**
     * 重量
     */
    @ApiModelProperty("重量")
    @Excel(name = "重量")
    private BigDecimal weight;

    /**
     * 织造米数
     */
    @ApiModelProperty("织造米数")
    @Excel(name = "织造米数")
    private BigDecimal length;

    /**
     * 开机时间
     */
    @ApiModelProperty("开机时间")
    @Excel(name = "开机时间")
    private Long openTime;

    /**
     * 停机时间
     */
    @ApiModelProperty("停机时间")
    @Excel(name = "停机时间")
    private Long closeTime;

    /**
     * 创建人
     */
    @ApiModelProperty("创建人")
    @Excel(name = "创建人")
    private String createdBy;

    /**
     * 创建时间
     */
    @ApiModelProperty("创建时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @Excel(name = "创建时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date createdTime;

    /**
     * 更新人
     */
    @ApiModelProperty("更新人")
    @Excel(name = "更新人")
    private String updatedBy;

    /**
     * 更新时间
     */
    @ApiModelProperty("更新时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @Excel(name = "更新时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date updatedTime;

}
