package com.jjt.emp.domain;

import com.baomidou.mybatisplus.annotation.TableId;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.jjt.common.annotation.Excel;
import com.jjt.common.core.domain.BaseEntity;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;
import java.util.List;

/**
 * 员工排班对象 TWIN_EMP
 *
 * @author wukai
 * @date 2025-01-18
 */
@ApiModel(value = "TwinEmp", description = "员工排班")
@Data
public class TwinEmp extends BaseEntity {
    private static final long serialVersionUID = 1L;

    /**
     * 排班ID
     */
    @ApiModelProperty("排班ID")
    @TableId
    private Long empId;

    /**
     * 时间
     */
    @ApiModelProperty("时间")
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date empDate;

    /**
     * 员工排班明细信息
     */
    private List<TwinEmpDetail> twinEmpDetailList;
    private List<TwinEmpDetail> twinEmpDetailListA;
    private List<TwinEmpDetail> twinEmpDetailListB;

}
