package com.jjt.ws.domain;

import java.math.BigDecimal;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.baomidou.mybatisplus.annotation.TableId;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.jjt.common.annotation.Excel;
import com.jjt.common.core.domain.BaseEntity;

/**
 * 能源统计对象 TWIN_WORKSHOP_CALC
 *
 * @author wukai
 * @date 2025-01-17
 */
@ApiModel(value = "TwinWorkshopCalc", description = "能源统计")
@Data
public class TwinWorkshopCalc extends BaseEntity{
    private static final long serialVersionUID = 1L;

    /** 统计ID */
    @ApiModelProperty("统计ID")
    @TableId
    private Long calcId;

    /** 日期 */
    @ApiModelProperty("日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @Excel(name = "日期", width = 30, dateFormat = "yyyy-MM-dd")
    private Date dataDate;

    /** 车间ID */
    @ApiModelProperty("车间ID")
    @Excel(name = "车间ID")
    private Long wsId;

    /** A班统计 */
    @ApiModelProperty("A班统计")
    @Excel(name = "A班统计")
    private BigDecimal aValue;

    /** B班统计 */
    @ApiModelProperty("B班统计")
    @Excel(name = "B班统计")
    private BigDecimal bValue;

}
