package com.jjt.ws.domain;

import com.jjt.common.annotation.Excel;
import com.jjt.common.core.domain.BaseEntity;
import lombok.Data;

import java.math.BigDecimal;

/**
 * 车间能源管理对象 TWIN_WORKSHOP_ENERGY
 *
 * @author wukai
 * @date 2025-01-17
 */
@Data
public class TwinWorkshopEnergy extends BaseEntity {
    private static final long serialVersionUID = 1L;

    /**
     * 能源ID
     */
    private Long energyId;

    /**
     * 车间ID
     */
    @Excel(name = "车间ID")
    private Long wsId;

    /**
     * 能源设备名称
     */
    @Excel(name = "能源设备名称")
    private String energyName;

    /**
     * 能源设备类型
     */
    @Excel(name = "能源设备类型")
    private String energyType;

    /**
     * 能源设备路径
     */
    @Excel(name = "能源设备路径")
    private String energyPath;

    /**
     * 字段编码
     */
    @Excel(name = "字段编码")
    private String energyCode;

    /**
     * 计算系数
     */
    @Excel(name = "计算系数")
    private BigDecimal coefficient;

}
