package com.jjt.ws.mapper;

import java.util.List;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.jjt.ws.domain.TwinWorkshopEnergy;

/**
 * 车间能源管理Mapper接口
 * 
 * @author wukai
 * @date 2025-01-17
 */
public interface TwinWorkshopEnergyMapper extends BaseMapper<TwinWorkshopEnergy>
{
    /**
     * 查询车间能源管理
     * 
     * @param energyId 车间能源管理主键
     * @return 车间能源管理
     */
    public TwinWorkshopEnergy selectTwinWorkshopEnergyByEnergyId(Long energyId);

    /**
     * 查询车间能源管理列表
     * 
     * @param twinWorkshopEnergy 车间能源管理
     * @return 车间能源管理集合
     */
    public List<TwinWorkshopEnergy> selectTwinWorkshopEnergyList(TwinWorkshopEnergy twinWorkshopEnergy);

    /**
     * 新增车间能源管理
     * 
     * @param twinWorkshopEnergy 车间能源管理
     * @return 结果
     */
    public int insertTwinWorkshopEnergy(TwinWorkshopEnergy twinWorkshopEnergy);

    /**
     * 修改车间能源管理
     * 
     * @param twinWorkshopEnergy 车间能源管理
     * @return 结果
     */
    public int updateTwinWorkshopEnergy(TwinWorkshopEnergy twinWorkshopEnergy);

    /**
     * 删除车间能源管理
     * 
     * @param energyId 车间能源管理主键
     * @return 结果
     */
    public int deleteTwinWorkshopEnergyByEnergyId(Long energyId);

    /**
     * 批量删除车间能源管理
     * 
     * @param energyIds 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteTwinWorkshopEnergyByEnergyIds(Long[] energyIds);
}
